Index: /trunk/install.pri
===================================================================
--- /trunk/install.pri	(revision 151)
+++ /trunk/install.pri	(revision 152)
@@ -15,5 +15,5 @@
 #share.files =
 docs.files = COPYING ChangeLog.txt README.txt INSTALL.txt
-INSTALLS += target share docs # l10n
+INSTALLS += target docs # share l10n
 
 # For *nix:
@@ -62,10 +62,8 @@
 			$$[QT_INSTALL_BINS]/libgcc_s_dw2-1.dll
 	}
-#	iconengines.files = $$[QT_INSTALL_PLUGINS]/iconengines/qsvgicon$${D}4.dll
-#	iconengines.path = $$PREFIX/TSPSG/iconengines
 	imageformats.files = $$[QT_INSTALL_PLUGINS]/imageformats/qjpeg$${D}4.dll \
 		$$[QT_INSTALL_PLUGINS]/imageformats/qtiff$${D}4.dll
 	imageformats.path = $$PREFIX/TSPSG/imageformats
-	INSTALLS += imageformats # iconengines
+	INSTALLS += share imageformats
 }
 
@@ -81,5 +79,5 @@
 
 	DEPLOYMENT += target share docs # l10n
-#	DEPLOYMENT_PLUGIN += qjpeg qtiff qsvgicon
+	DEPLOYMENT_PLUGIN += qjpeg qtiff
 }
 
@@ -94,6 +92,6 @@
 # Symbian
 symbian {
+	share.sources = $$share.files
 	# qmake for Symbian (as of Qt 4.6.2) has a bug: file masks doesn't work, so we need to specify all files manually
-	share.sources = $$share.files
 #	l10n.sources = $$[QT_INSTALL_TRANSLATIONS]/qt_ru.qm \
 #		$$[QT_INSTALL_TRANSLATIONS]/qt_uk.qm \
@@ -110,8 +108,8 @@
 
 	appinfo = \
-		"$$LITERAL_HASH{\"TSPSG\"},(0xEb9dce0e),$$BUILD_VERSION_MAJOR,$$BUILD_VERSION_MINOR,$$BUILD_RELEASE"
+		"$$LITERAL_HASH{\"TSP Solver and Generator\"},(0xA89FD7A3),$$BUILD_VERSION_MAJOR,$$BUILD_VERSION_MINOR,$$BUILD_RELEASE"
 	vendorinfo = \
-		"%{\"l-homes.org\"}" \
-		":\"l-homes.org\""
+		"%{\"Oleksii Serdiuk\"}" \
+		":\"Oleksii Serdiuk\""
 	default_deployment.pkg_prerules = appinfo vendorinfo
 	DEPLOYMENT.installer_header = "$${LITERAL_HASH}{\"TSPSG Installer\"},(0xA000D7CE),1,0,0"
Index: /trunk/resources/tspsg.desktop
===================================================================
--- /trunk/resources/tspsg.desktop	(revision 151)
+++ /trunk/resources/tspsg.desktop	(revision 152)
@@ -1,16 +1,13 @@
 [Desktop Entry]
 Encoding=UTF-8
+Version=1.0
 Type=Application
-Version=0.1
-Name=TSPSG: TSP Solver and Generator
+Terminal=false
+Name=TSP Solver and Generator
 GenericName=Solving Travelling Salesman Problem using Branch and Bound method
 GenericName[ru]=Решение задачи коммивояжера методом ветвей и границ
 GenericName[uk]=Розв'язання задачі комівояжера методом гілок та меж
-Comment=Solving Travelling Salesman Problem using Branch and Bound method
-Comment[ru]=Решение задачи коммивояжера методом ветвей и границ
-Comment[uk]=Розв'язання задачі комівояжера методом гілок та меж
+Exec=tspsg %f
 Icon=tspsg
-Exec=tspsg %f
-Terminal=false
-Categories=Qt;KDE;Education;Math;
+Categories=Qt;KDE;Education;Science;Math;
 StartupNotify=true
Index: /trunk/tspsg.pro
===================================================================
--- /trunk/tspsg.pro	(revision 151)
+++ /trunk/tspsg.pro	(revision 152)
@@ -42,5 +42,7 @@
 
 #REVISION = 145
-REVISION = $$system(svnversion)
+isEmpty(REVISION) {
+	REVISION = $$system(svnversion)
+}
 isEmpty(REVISION)|isEqual(REVISION,exported) {
 	REVISION = 0
@@ -64,6 +66,6 @@
 macx {
 	PRL = $$[QT_INSTALL_LIBS] QtCore.framework QtCore.prl
-} else:symbian {
-	PRL = $$[QT_INSTALL_LIBS] QtCore.prl
+} else:symbian|maemo* {
+	# Nothing here
 } else:unix {
 	PRL = $$[QT_INSTALL_LIBS] libQtCore.prl
@@ -71,9 +73,11 @@
 	PRL = $$[QT_INSTALL_LIBS] QtCore.prl
 }
-include($$join(PRL, "/"))
-contains(QMAKE_PRL_CONFIG, static) {
-	# We "embed" SVG icon support on static build
-	DEFINES += STATIC_BUILD
-#	!nosvg:QTPLUGIN += qsvgicon
+!isEmpty(PRL) {
+	include($$join(PRL, "/"))
+	contains(QMAKE_PRL_CONFIG, static) {
+		# We "embed" SVG icon support on static build
+		DEFINES += STATIC_BUILD
+#		!nosvg:QTPLUGIN += qsvgicon
+	}
 }
 
@@ -105,4 +109,4 @@
 include(tspsg.pri)
 
-# Installation and deployment
+# Installation and deployment rules
 include(install.pri)