Index: ui/mainwindow.ui
===================================================================
--- ui/mainwindow.ui	(revision b2bf8e3b6bff66c0d857cedf4d142262849d0a1a)
+++ ui/mainwindow.ui	(revision 162d5c5f94ddb4425bb75f17429259c97476b34c)
@@ -8,6 +8,6 @@
     <x>0</x>
     <y>0</y>
-    <width>301</width>
-    <height>352</height>
+    <width>500</width>
+    <height>450</height>
    </rect>
   </property>
@@ -253,5 +253,5 @@
      <x>0</x>
      <y>0</y>
-     <width>301</width>
+     <width>500</width>
      <height>21</height>
     </rect>
Index: ui/settingsdialog.ui
===================================================================
--- ui/settingsdialog.ui	(revision b2bf8e3b6bff66c0d857cedf4d142262849d0a1a)
+++ ui/settingsdialog.ui	(revision 162d5c5f94ddb4425bb75f17429259c97476b34c)
@@ -229,8 +229,11 @@
         <string>Task generation and solving settings</string>
        </attribute>
-       <layout class="QVBoxLayout" name="_5">
-        <item>
-         <layout class="QHBoxLayout" name="_10">
-          <item>
+       <layout class="QVBoxLayout" name="_9">
+        <item>
+         <layout class="QFormLayout" name="_5">
+          <property name="fieldGrowthPolicy">
+           <enum>QFormLayout::ExpandingFieldsGrow</enum>
+          </property>
+          <item row="0" column="0">
            <widget class="QLabel" name="labelFractionalAccuracy">
             <property name="text">
@@ -239,5 +242,5 @@
            </widget>
           </item>
-          <item>
+          <item row="0" column="1">
            <widget class="QSpinBox" name="spinFractionalAccuracy">
             <property name="cursor">
@@ -252,107 +255,90 @@
            </widget>
           </item>
-          <item>
-           <spacer name="spacer_3">
-            <property name="orientation">
-             <enum>Qt::Horizontal</enum>
-            </property>
-            <property name="sizeHint" stdset="0">
-             <size>
-              <width>0</width>
-              <height>0</height>
-             </size>
-            </property>
-           </spacer>
-          </item>
          </layout>
         </item>
         <item>
-         <layout class="QHBoxLayout" name="_7">
-          <item>
-           <widget class="QGroupBox" name="groupBox">
-            <property name="title">
-             <string>Random numbers</string>
-            </property>
-            <layout class="QVBoxLayout" name="_8">
-             <item>
-              <layout class="QFormLayout" name="_9">
-               <property name="fieldGrowthPolicy">
-                <enum>QFormLayout::ExpandingFieldsGrow</enum>
-               </property>
-               <item row="0" column="0">
-                <widget class="QLabel" name="labelRandMin">
-                 <property name="text">
-                  <string>&amp;Minimal:</string>
-                 </property>
-                 <property name="buddy">
-                  <cstring>spinRandMin</cstring>
-                 </property>
-                </widget>
-               </item>
-               <item row="0" column="1">
-                <widget class="QSpinBox" name="spinRandMin">
-                 <property name="cursor">
-                  <cursorShape>PointingHandCursor</cursorShape>
-                 </property>
-                 <property name="statusTip">
-                  <string>Minimum for random number generation</string>
-                 </property>
-                </widget>
-               </item>
-               <item row="1" column="0">
-                <widget class="QLabel" name="labelRandMax">
-                 <property name="text">
-                  <string>Ma&amp;ximal:</string>
-                 </property>
-                 <property name="buddy">
-                  <cstring>spinRandMax</cstring>
-                 </property>
-                </widget>
-               </item>
-               <item row="1" column="1">
-                <widget class="QSpinBox" name="spinRandMax">
-                 <property name="cursor">
-                  <cursorShape>PointingHandCursor</cursorShape>
-                 </property>
-                 <property name="statusTip">
-                  <string>Maximum for random number generation</string>
-                 </property>
-                </widget>
-               </item>
-              </layout>
+         <widget class="QCheckBox" name="cbSymmetricMode">
+          <property name="cursor">
+           <cursorShape>PointingHandCursor</cursorShape>
+          </property>
+          <property name="statusTip">
+           <string>In this mode the cost of travel from city 1 to city 2 and vice versa is the same</string>
+          </property>
+          <property name="text">
+           <string>Symmetric mode</string>
+          </property>
+         </widget>
+        </item>
+        <item>
+         <widget class="QGroupBox" name="gbTaskGeneration">
+          <property name="title">
+           <string>Task generation</string>
+          </property>
+          <layout class="QVBoxLayout" name="_7">
+           <item>
+            <layout class="QFormLayout" name="_8">
+             <property name="fieldGrowthPolicy">
+              <enum>QFormLayout::ExpandingFieldsGrow</enum>
+             </property>
+             <item row="0" column="0">
+              <widget class="QLabel" name="labelRandMin">
+               <property name="text">
+                <string>Minimal random:</string>
+               </property>
+               <property name="buddy">
+                <cstring>spinRandMin</cstring>
+               </property>
+              </widget>
              </item>
-             <item>
-              <widget class="QCheckBox" name="cbFractionalRandom">
+             <item row="0" column="1">
+              <widget class="QSpinBox" name="spinRandMin">
                <property name="cursor">
                 <cursorShape>PointingHandCursor</cursorShape>
                </property>
                <property name="statusTip">
-                <string>Generate fractional random values with the Fractional accuracy</string>
-               </property>
+                <string>Minimum for random number generation</string>
+               </property>
+              </widget>
+             </item>
+             <item row="1" column="0">
+              <widget class="QLabel" name="labelRandMax">
                <property name="text">
-                <string>Fractional random values</string>
+                <string>Maximal random:</string>
+               </property>
+               <property name="buddy">
+                <cstring>spinRandMax</cstring>
+               </property>
+              </widget>
+             </item>
+             <item row="1" column="1">
+              <widget class="QSpinBox" name="spinRandMax">
+               <property name="cursor">
+                <cursorShape>PointingHandCursor</cursorShape>
+               </property>
+               <property name="statusTip">
+                <string>Maximum for random number generation</string>
                </property>
               </widget>
              </item>
             </layout>
-           </widget>
-          </item>
-          <item>
-           <spacer name="spacer_2">
-            <property name="orientation">
-             <enum>Qt::Horizontal</enum>
-            </property>
-            <property name="sizeHint" stdset="0">
-             <size>
-              <width>0</width>
-              <height>0</height>
-             </size>
-            </property>
-           </spacer>
-          </item>
-         </layout>
-        </item>
-        <item>
-         <spacer name="spacer_5">
+           </item>
+           <item>
+            <widget class="QCheckBox" name="cbFractionalRandom">
+             <property name="cursor">
+              <cursorShape>PointingHandCursor</cursorShape>
+             </property>
+             <property name="statusTip">
+              <string>Generate fractional random values with the Fractional accuracy</string>
+             </property>
+             <property name="text">
+              <string>Fractional random values</string>
+             </property>
+            </widget>
+           </item>
+          </layout>
+         </widget>
+        </item>
+        <item>
+         <spacer name="spacer_2">
           <property name="orientation">
            <enum>Qt::Vertical</enum>
@@ -360,5 +346,5 @@
           <property name="sizeHint" stdset="0">
            <size>
-            <width>0</width>
+            <width>10</width>
             <height>0</height>
            </size>
@@ -395,5 +381,5 @@
           </property>
           <item>
-           <spacer name="spacer_4">
+           <spacer name="spacer_3">
             <property name="orientation">
              <enum>Qt::Horizontal</enum>
@@ -437,5 +423,5 @@
           </item>
           <item>
-           <spacer name="spacer_6">
+           <spacer name="spacer_4">
             <property name="orientation">
              <enum>Qt::Horizontal</enum>
@@ -471,5 +457,5 @@
              <string>Output font settings</string>
             </property>
-            <layout class="QHBoxLayout" name="horizontalLayout">
+            <layout class="QHBoxLayout" name="_13">
              <item>
               <widget class="QPushButton" name="buttonFont">
@@ -506,24 +492,24 @@
               </widget>
              </item>
+             <item>
+              <spacer name="spacer_5">
+               <property name="orientation">
+                <enum>Qt::Horizontal</enum>
+               </property>
+               <property name="sizeHint" stdset="0">
+                <size>
+                 <width>0</width>
+                 <height>0</height>
+                </size>
+               </property>
+              </spacer>
+             </item>
             </layout>
            </widget>
           </item>
-          <item>
-           <spacer name="spacer_7">
-            <property name="orientation">
-             <enum>Qt::Horizontal</enum>
-            </property>
-            <property name="sizeHint" stdset="0">
-             <size>
-              <width>0</width>
-              <height>0</height>
-             </size>
-            </property>
-           </spacer>
-          </item>
          </layout>
         </item>
         <item>
-         <spacer name="verticalSpacer">
+         <spacer name="spacer_6">
           <property name="orientation">
            <enum>Qt::Vertical</enum>