Index: ui/mainwindow.ce.ui
===================================================================
--- ui/mainwindow.ce.ui	(revision 5354a013118fd7e0ec3e0680ec9c806f5ba5ac4c)
+++ ui/mainwindow.ce.ui	(revision 665d32434fd2274557d46c48de96a5bbce52703d)
@@ -350,7 +350,4 @@
     <string>Сохранить ход и граф решения</string>
    </property>
-   <property name="shortcut">
-    <string>Ctrl+S</string>
-   </property>
   </action>
   <action name="actionFileNew">
Index: ui/mainwindow.ui
===================================================================
--- ui/mainwindow.ui	(revision 5354a013118fd7e0ec3e0680ec9c806f5ba5ac4c)
+++ ui/mainwindow.ui	(revision 665d32434fd2274557d46c48de96a5bbce52703d)
@@ -369,7 +369,4 @@
     <string>Сохранить ход и граф решения</string>
    </property>
-   <property name="shortcut">
-    <string>Ctrl+S</string>
-   </property>
   </action>
   <action name="actionFileNew">
Index: ui/settingsdialog.ce.ui
===================================================================
--- ui/settingsdialog.ce.ui	(revision 5354a013118fd7e0ec3e0680ec9c806f5ba5ac4c)
+++ ui/settingsdialog.ce.ui	(revision 665d32434fd2274557d46c48de96a5bbce52703d)
@@ -7,5 +7,5 @@
     <x>0</x>
     <y>0</y>
-    <width>229</width>
+    <width>235</width>
     <height>264</height>
    </rect>
@@ -195,4 +195,15 @@
         </item>
         <item>
+         <widget class="QPushButton" name="buttonColor">
+          <property name="text">
+           <string>&amp;Цвет...</string>
+          </property>
+          <property name="icon">
+           <iconset resource="../resources/tspsg.qrc">
+            <normaloff>:/images/buttons/buttons/Color.png</normaloff>:/images/buttons/buttons/Color.png</iconset>
+          </property>
+         </widget>
+        </item>
+        <item>
          <widget class="QPushButton" name="buttonFont">
           <property name="cursor">
@@ -226,51 +237,4 @@
        </spacer>
       </item>
-      <item>
-       <layout class="QHBoxLayout" name="horizontalLayout">
-        <item>
-         <spacer name="horizontalSpacer">
-          <property name="orientation">
-           <enum>Qt::Horizontal</enum>
-          </property>
-          <property name="sizeHint" stdset="0">
-           <size>
-            <width>40</width>
-            <height>20</height>
-           </size>
-          </property>
-         </spacer>
-        </item>
-        <item>
-         <widget class="QCheckBox" name="checkBox">
-          <property name="cursor">
-           <cursorShape>PointingHandCursor</cursorShape>
-          </property>
-          <property name="statusTip">
-           <string>Восстанавливать состояние и размеры окна после перезапуска программы</string>
-          </property>
-          <property name="text">
-           <string>Сохранять состояние и
-положение главного окна</string>
-          </property>
-          <property name="checked">
-           <bool>false</bool>
-          </property>
-         </widget>
-        </item>
-        <item>
-         <spacer name="horizontalSpacer_2">
-          <property name="orientation">
-           <enum>Qt::Horizontal</enum>
-          </property>
-          <property name="sizeHint" stdset="0">
-           <size>
-            <width>40</width>
-            <height>20</height>
-           </size>
-          </property>
-         </spacer>
-        </item>
-       </layout>
-      </item>
      </layout>
     </widget>
Index: ui/settingsdialog.ui
===================================================================
--- ui/settingsdialog.ui	(revision 5354a013118fd7e0ec3e0680ec9c806f5ba5ac4c)
+++ ui/settingsdialog.ui	(revision 665d32434fd2274557d46c48de96a5bbce52703d)
@@ -7,5 +7,5 @@
     <x>0</x>
     <y>0</y>
-    <width>436</width>
+    <width>466</width>
     <height>172</height>
    </rect>
@@ -235,5 +235,5 @@
              <string>Настройки печати:</string>
             </property>
-            <layout class="QVBoxLayout">
+            <layout class="QVBoxLayout" name="verticalLayout">
              <item>
               <layout class="QHBoxLayout">
@@ -270,18 +270,35 @@
              </item>
              <item>
-              <widget class="QPushButton" name="buttonFont">
-               <property name="cursor">
-                <cursorShape>PointingHandCursor</cursorShape>
+              <widget class="QSplitter" name="splitter">
+               <property name="orientation">
+                <enum>Qt::Horizontal</enum>
                </property>
-               <property name="statusTip">
-                <string>Задать параметры шрифта, используемого при печати</string>
-               </property>
-               <property name="text">
-                <string>&amp;Шрифт...</string>
-               </property>
-               <property name="icon">
-                <iconset resource="../resources/tspsg.qrc">
-                 <normaloff>:/images/buttons/buttons/Font.png</normaloff>:/images/buttons/buttons/Font.png</iconset>
-               </property>
+               <widget class="QPushButton" name="buttonColor">
+                <property name="cursor">
+                 <cursorShape>PointingHandCursor</cursorShape>
+                </property>
+                <property name="text">
+                 <string>&amp;Цвет...</string>
+                </property>
+                <property name="icon">
+                 <iconset resource="../resources/tspsg.qrc">
+                  <normaloff>:/images/buttons/buttons/Color.png</normaloff>:/images/buttons/buttons/Color.png</iconset>
+                </property>
+               </widget>
+               <widget class="QPushButton" name="buttonFont">
+                <property name="cursor">
+                 <cursorShape>PointingHandCursor</cursorShape>
+                </property>
+                <property name="statusTip">
+                 <string>Задать параметры шрифта, используемого при печати</string>
+                </property>
+                <property name="text">
+                 <string>&amp;Шрифт...</string>
+                </property>
+                <property name="icon">
+                 <iconset resource="../resources/tspsg.qrc">
+                  <normaloff>:/images/buttons/buttons/Font.png</normaloff>:/images/buttons/buttons/Font.png</iconset>
+                </property>
+               </widget>
               </widget>
              </item>
@@ -292,5 +309,5 @@
         </item>
         <item>
-         <widget class="QCheckBox" name="checkBox">
+         <widget class="QCheckBox" name="cbSaveState">
           <property name="cursor">
            <cursorShape>PointingHandCursor</cursorShape>
@@ -427,4 +444,5 @@
  <resources>
   <include location="../resources/tspsg.qrc"/>
+  <include location="../resources/tspsg.qrc"/>
  </resources>
  <connections/>