Index: ui/settingsdialog.ui
===================================================================
--- ui/settingsdialog.ui	(revision 95eca626aadef27c386b2655604128077c74badc)
+++ ui/settingsdialog.ui	(revision 799ba1e3f23fc7c497ea47cffb218803ccdbabbd)
@@ -1,6 +1,7 @@
-<ui version="4.0" >
+<?xml version="1.0" encoding="UTF-8"?>
+<ui version="4.0">
  <class>SettingsDialog</class>
- <widget class="QWidget" name="SettingsDialog" >
-  <property name="geometry" >
+ <widget class="QWidget" name="SettingsDialog">
+  <property name="geometry">
    <rect>
     <x>0</x>
@@ -10,34 +11,26 @@
    </rect>
   </property>
-  <property name="windowTitle" >
+  <property name="windowTitle">
    <string>Параметры</string>
   </property>
-  <property name="windowIcon" >
-   <iconset resource="../resources/tspsg.qrc" >:/images/Settings.png</iconset>
+  <property name="windowIcon">
+   <iconset resource="../resources/tspsg.qrc">
+    <normaloff>:/images/Settings.png</normaloff>:/images/Settings.png</iconset>
   </property>
-  <layout class="QVBoxLayout" >
-   <property name="spacing" >
+  <layout class="QVBoxLayout">
+   <property name="spacing">
     <number>0</number>
    </property>
-   <property name="leftMargin" >
-    <number>0</number>
-   </property>
-   <property name="topMargin" >
-    <number>0</number>
-   </property>
-   <property name="rightMargin" >
-    <number>0</number>
-   </property>
-   <property name="bottomMargin" >
+   <property name="margin">
     <number>0</number>
    </property>
    <item>
-    <layout class="QHBoxLayout" >
-     <property name="spacing" >
+    <layout class="QHBoxLayout">
+     <property name="spacing">
       <number>0</number>
      </property>
      <item>
-      <widget class="QLabel" name="imageSide" >
-       <property name="minimumSize" >
+      <widget class="QLabel" name="imageSide">
+       <property name="minimumSize">
         <size>
          <width>130</width>
@@ -45,20 +38,20 @@
         </size>
        </property>
-       <property name="styleSheet" >
+       <property name="styleSheet">
         <string>background-color: #0080C0</string>
        </property>
-       <property name="frameShape" >
+       <property name="frameShape">
         <enum>QFrame::StyledPanel</enum>
        </property>
-       <property name="lineWidth" >
+       <property name="lineWidth">
         <number>0</number>
        </property>
-       <property name="text" >
+       <property name="text">
         <string/>
        </property>
-       <property name="pixmap" >
-        <pixmap resource="../resources/tspsg.qrc" >:/images/Settings.png</pixmap>
-       </property>
-       <property name="alignment" >
+       <property name="pixmap">
+        <pixmap resource="../resources/tspsg.qrc">:/images/Settings.png</pixmap>
+       </property>
+       <property name="alignment">
         <set>Qt::AlignCenter</set>
        </property>
@@ -66,12 +59,12 @@
      </item>
      <item>
-      <widget class="Line" name="lineVertical" >
-       <property name="frameShadow" >
+      <widget class="Line" name="lineVertical">
+       <property name="frameShadow">
         <enum>QFrame::Plain</enum>
        </property>
-       <property name="lineWidth" >
+       <property name="lineWidth">
         <number>2</number>
        </property>
-       <property name="orientation" >
+       <property name="orientation">
         <enum>Qt::Vertical</enum>
        </property>
@@ -79,20 +72,20 @@
      </item>
      <item>
-      <widget class="QWidget" native="1" name="background" >
-       <property name="palette" >
+      <widget class="QWidget" name="background" native="true">
+       <property name="palette">
         <palette>
          <active>
-          <colorrole role="Base" >
-           <brush brushstyle="SolidPattern" >
-            <color alpha="255" >
-             <red>255</red>
-             <green>255</green>
-             <blue>255</blue>
-            </color>
-           </brush>
-          </colorrole>
-          <colorrole role="Window" >
-           <brush brushstyle="SolidPattern" >
-            <color alpha="255" >
+          <colorrole role="Base">
+           <brush brushstyle="SolidPattern">
+            <color alpha="255">
+             <red>255</red>
+             <green>255</green>
+             <blue>255</blue>
+            </color>
+           </brush>
+          </colorrole>
+          <colorrole role="Window">
+           <brush brushstyle="SolidPattern">
+            <color alpha="255">
              <red>255</red>
              <green>255</green>
@@ -103,16 +96,16 @@
          </active>
          <inactive>
-          <colorrole role="Base" >
-           <brush brushstyle="SolidPattern" >
-            <color alpha="255" >
-             <red>255</red>
-             <green>255</green>
-             <blue>255</blue>
-            </color>
-           </brush>
-          </colorrole>
-          <colorrole role="Window" >
-           <brush brushstyle="SolidPattern" >
-            <color alpha="255" >
+          <colorrole role="Base">
+           <brush brushstyle="SolidPattern">
+            <color alpha="255">
+             <red>255</red>
+             <green>255</green>
+             <blue>255</blue>
+            </color>
+           </brush>
+          </colorrole>
+          <colorrole role="Window">
+           <brush brushstyle="SolidPattern">
+            <color alpha="255">
              <red>255</red>
              <green>255</green>
@@ -123,16 +116,16 @@
          </inactive>
          <disabled>
-          <colorrole role="Base" >
-           <brush brushstyle="SolidPattern" >
-            <color alpha="255" >
-             <red>255</red>
-             <green>255</green>
-             <blue>255</blue>
-            </color>
-           </brush>
-          </colorrole>
-          <colorrole role="Window" >
-           <brush brushstyle="SolidPattern" >
-            <color alpha="255" >
+          <colorrole role="Base">
+           <brush brushstyle="SolidPattern">
+            <color alpha="255">
+             <red>255</red>
+             <green>255</green>
+             <blue>255</blue>
+            </color>
+           </brush>
+          </colorrole>
+          <colorrole role="Window">
+           <brush brushstyle="SolidPattern">
+            <color alpha="255">
              <red>255</red>
              <green>255</green>
@@ -144,33 +137,33 @@
         </palette>
        </property>
-       <property name="autoFillBackground" >
+       <property name="autoFillBackground">
         <bool>true</bool>
        </property>
-       <layout class="QVBoxLayout" >
+       <layout class="QVBoxLayout">
         <item>
-         <layout class="QHBoxLayout" >
-          <property name="spacing" >
+         <layout class="QHBoxLayout">
+          <property name="spacing">
            <number>6</number>
           </property>
           <item>
-           <widget class="QGroupBox" name="groupRandomSettings" >
-            <property name="title" >
+           <widget class="QGroupBox" name="groupRandomSettings">
+            <property name="title">
              <string>Случайные значения:</string>
             </property>
-            <layout class="QVBoxLayout" >
+            <layout class="QVBoxLayout">
              <item>
-              <layout class="QHBoxLayout" >
-               <item>
-                <widget class="QLabel" name="labelRandMin" >
-                 <property name="sizePolicy" >
-                  <sizepolicy vsizetype="Preferred" hsizetype="Expanding" >
+              <layout class="QHBoxLayout">
+               <item>
+                <widget class="QLabel" name="labelRandMin">
+                 <property name="sizePolicy">
+                  <sizepolicy hsizetype="Expanding" vsizetype="Preferred">
                    <horstretch>0</horstretch>
                    <verstretch>0</verstretch>
                   </sizepolicy>
                  </property>
-                 <property name="text" >
+                 <property name="text">
                   <string>Ми&amp;нимум:</string>
                  </property>
-                 <property name="buddy" >
+                 <property name="buddy">
                   <cstring>spinRandMin</cstring>
                  </property>
@@ -178,15 +171,15 @@
                </item>
                <item>
-                <widget class="QSpinBox" name="spinRandMin" >
-                 <property name="cursor" >
+                <widget class="QSpinBox" name="spinRandMin">
+                 <property name="cursor">
                   <cursorShape>PointingHandCursor</cursorShape>
                  </property>
-                 <property name="statusTip" >
+                 <property name="statusTip">
                   <string>Нижняя граница для генерации случайных значений</string>
                  </property>
-                 <property name="maximum" >
+                 <property name="maximum">
                   <number>1000</number>
                  </property>
-                 <property name="value" >
+                 <property name="value">
                   <number>1</number>
                  </property>
@@ -196,17 +189,17 @@
              </item>
              <item>
-              <layout class="QHBoxLayout" >
-               <item>
-                <widget class="QLabel" name="labelRandMax" >
-                 <property name="sizePolicy" >
-                  <sizepolicy vsizetype="Preferred" hsizetype="Expanding" >
+              <layout class="QHBoxLayout">
+               <item>
+                <widget class="QLabel" name="labelRandMax">
+                 <property name="sizePolicy">
+                  <sizepolicy hsizetype="Expanding" vsizetype="Preferred">
                    <horstretch>0</horstretch>
                    <verstretch>0</verstretch>
                   </sizepolicy>
                  </property>
-                 <property name="text" >
+                 <property name="text">
                   <string>&amp;Максимум:</string>
                  </property>
-                 <property name="buddy" >
+                 <property name="buddy">
                   <cstring>spinRandMax</cstring>
                  </property>
@@ -214,18 +207,18 @@
                </item>
                <item>
-                <widget class="QSpinBox" name="spinRandMax" >
-                 <property name="cursor" >
+                <widget class="QSpinBox" name="spinRandMax">
+                 <property name="cursor">
                   <cursorShape>PointingHandCursor</cursorShape>
                  </property>
-                 <property name="statusTip" >
+                 <property name="statusTip">
                   <string>Верхняя граница для генерации случайных значений</string>
                  </property>
-                 <property name="minimum" >
+                 <property name="minimum">
                   <number>1</number>
                  </property>
-                 <property name="maximum" >
+                 <property name="maximum">
                   <number>1000</number>
                  </property>
-                 <property name="value" >
+                 <property name="value">
                   <number>10</number>
                  </property>
@@ -238,17 +231,17 @@
           </item>
           <item>
-           <widget class="QGroupBox" name="groupPrintSetup" >
-            <property name="title" >
+           <widget class="QGroupBox" name="groupPrintSetup">
+            <property name="title">
              <string>Настройки печати:</string>
             </property>
-            <layout class="QVBoxLayout" >
+            <layout class="QVBoxLayout">
              <item>
-              <layout class="QHBoxLayout" >
-               <item>
-                <widget class="QLabel" name="labelLeftMargin" >
-                 <property name="text" >
+              <layout class="QHBoxLayout">
+               <item>
+                <widget class="QLabel" name="labelLeftMargin">
+                 <property name="text">
                   <string>&amp;Левый отступ:</string>
                  </property>
-                 <property name="buddy" >
+                 <property name="buddy">
                   <cstring>spinLeftMargin</cstring>
                  </property>
@@ -256,18 +249,18 @@
                </item>
                <item>
-                <widget class="QSpinBox" name="spinLeftMargin" >
-                 <property name="cursor" >
+                <widget class="QSpinBox" name="spinLeftMargin">
+                 <property name="cursor">
                   <cursorShape>PointingHandCursor</cursorShape>
                  </property>
-                 <property name="statusTip" >
+                 <property name="statusTip">
                   <string>Размер отступа от левого края страницы</string>
                  </property>
-                 <property name="maximum" >
+                 <property name="maximum">
                   <number>999</number>
                  </property>
-                 <property name="singleStep" >
+                 <property name="singleStep">
                   <number>10</number>
                  </property>
-                 <property name="value" >
+                 <property name="value">
                   <number>100</number>
                  </property>
@@ -277,16 +270,17 @@
              </item>
              <item>
-              <widget class="QPushButton" name="buttonFont" >
-               <property name="cursor" >
+              <widget class="QPushButton" name="buttonFont">
+               <property name="cursor">
                 <cursorShape>PointingHandCursor</cursorShape>
                </property>
-               <property name="statusTip" >
+               <property name="statusTip">
                 <string>Задать параметры шрифта, используемого при печати</string>
                </property>
-               <property name="text" >
+               <property name="text">
                 <string>&amp;Шрифт...</string>
                </property>
-               <property name="icon" >
-                <iconset resource="../resources/tspsg.qrc" >:/images/buttons/buttons/Font.png</iconset>
+               <property name="icon">
+                <iconset resource="../resources/tspsg.qrc">
+                 <normaloff>:/images/buttons/buttons/Font.png</normaloff>:/images/buttons/buttons/Font.png</iconset>
                </property>
               </widget>
@@ -298,12 +292,12 @@
         </item>
         <item>
-         <widget class="QCheckBox" name="checkBox" >
-          <property name="cursor" >
+         <widget class="QCheckBox" name="checkBox">
+          <property name="cursor">
            <cursorShape>PointingHandCursor</cursorShape>
           </property>
-          <property name="statusTip" >
+          <property name="statusTip">
            <string>Восстанавливать состояние и размеры окна после перезапуска программы</string>
           </property>
-          <property name="text" >
+          <property name="text">
            <string>Сохранять состояние и положение главного окна</string>
           </property>
@@ -316,6 +310,6 @@
    </item>
    <item>
-    <widget class="Line" name="lineHorizontal" >
-     <property name="maximumSize" >
+    <widget class="Line" name="lineHorizontal">
+     <property name="maximumSize">
       <size>
        <width>16777215</width>
@@ -323,11 +317,11 @@
       </size>
      </property>
-     <property name="frameShadow" >
+     <property name="frameShadow">
       <enum>QFrame::Plain</enum>
      </property>
-     <property name="lineWidth" >
+     <property name="lineWidth">
       <number>2</number>
      </property>
-     <property name="orientation" >
+     <property name="orientation">
       <enum>Qt::Horizontal</enum>
      </property>
@@ -335,38 +329,30 @@
    </item>
    <item>
-    <layout class="QHBoxLayout" >
-     <property name="spacing" >
+    <layout class="QHBoxLayout">
+     <property name="spacing">
       <number>6</number>
      </property>
-     <property name="leftMargin" >
+     <property name="margin">
       <number>6</number>
      </property>
-     <property name="topMargin" >
-      <number>6</number>
-     </property>
-     <property name="rightMargin" >
-      <number>6</number>
-     </property>
-     <property name="bottomMargin" >
-      <number>6</number>
-     </property>
-     <item>
-      <widget class="QToolButton" name="toolButton" >
-       <property name="cursor" >
+     <item>
+      <widget class="QToolButton" name="toolButton">
+       <property name="cursor">
         <cursorShape>PointingHandCursor</cursorShape>
        </property>
-       <property name="toolTip" >
+       <property name="toolTip">
         <string>Справка</string>
        </property>
-       <property name="statusTip" >
+       <property name="statusTip">
         <string>Получить помощь по настройкам</string>
        </property>
-       <property name="text" >
+       <property name="text">
         <string>Помощь</string>
        </property>
-       <property name="icon" >
-        <iconset resource="../resources/tspsg.qrc" >:/images/buttons/buttons/Help.png</iconset>
-       </property>
-       <property name="autoRaise" >
+       <property name="icon">
+        <iconset resource="../resources/tspsg.qrc">
+         <normaloff>:/images/buttons/buttons/Help.png</normaloff>:/images/buttons/buttons/Help.png</iconset>
+       </property>
+       <property name="autoRaise">
         <bool>true</bool>
        </property>
@@ -374,24 +360,24 @@
      </item>
      <item>
-      <widget class="QLabel" name="labelHint" >
-       <property name="sizePolicy" >
-        <sizepolicy vsizetype="Preferred" hsizetype="Expanding" >
+      <widget class="QLabel" name="labelHint">
+       <property name="sizePolicy">
+        <sizepolicy hsizetype="Expanding" vsizetype="Preferred">
          <horstretch>0</horstretch>
          <verstretch>0</verstretch>
         </sizepolicy>
        </property>
-       <property name="statusTip" >
+       <property name="statusTip">
         <string>Наведите указатель мыши на элемент диалога, чтоб получить подсказку</string>
        </property>
-       <property name="text" >
+       <property name="text">
         <string/>
        </property>
-       <property name="textFormat" >
+       <property name="textFormat">
         <enum>Qt::PlainText</enum>
        </property>
-       <property name="alignment" >
+       <property name="alignment">
         <set>Qt::AlignJustify|Qt::AlignTop</set>
        </property>
-       <property name="wordWrap" >
+       <property name="wordWrap">
         <bool>true</bool>
        </property>
@@ -399,18 +385,19 @@
      </item>
      <item>
-      <widget class="QPushButton" name="buttonOK" >
-       <property name="cursor" >
+      <widget class="QPushButton" name="buttonOK">
+       <property name="cursor">
         <cursorShape>PointingHandCursor</cursorShape>
        </property>
-       <property name="statusTip" >
+       <property name="statusTip">
         <string>Сохранить новые параметры</string>
        </property>
-       <property name="text" >
+       <property name="text">
         <string>&amp;OK</string>
        </property>
-       <property name="icon" >
-        <iconset resource="../resources/tspsg.qrc" >:/images/buttons/buttons/OK.png</iconset>
-       </property>
-       <property name="default" >
+       <property name="icon">
+        <iconset resource="../resources/tspsg.qrc">
+         <normaloff>:/images/buttons/buttons/OK.png</normaloff>:/images/buttons/buttons/OK.png</iconset>
+       </property>
+       <property name="default">
         <bool>true</bool>
        </property>
@@ -418,16 +405,17 @@
      </item>
      <item>
-      <widget class="QPushButton" name="buttonCancel" >
-       <property name="cursor" >
+      <widget class="QPushButton" name="buttonCancel">
+       <property name="cursor">
         <cursorShape>PointingHandCursor</cursorShape>
        </property>
-       <property name="statusTip" >
+       <property name="statusTip">
         <string>Закрыть окно без сохранения параметров</string>
        </property>
-       <property name="text" >
+       <property name="text">
         <string>&amp;Отмена</string>
        </property>
-       <property name="icon" >
-        <iconset resource="../resources/tspsg.qrc" >:/images/buttons/buttons/Critical.png</iconset>
+       <property name="icon">
+        <iconset resource="../resources/tspsg.qrc">
+         <normaloff>:/images/buttons/buttons/Critical.png</normaloff>:/images/buttons/buttons/Critical.png</iconset>
        </property>
       </widget>
@@ -438,5 +426,5 @@
  </widget>
  <resources>
-  <include location="../resources/tspsg.qrc" />
+  <include location="../resources/tspsg.qrc"/>
  </resources>
  <connections/>