Index: i18n/English.ts
===================================================================
--- i18n/English.ts	(revision 721c99d48236b5bc2472843c8b4ba373b580a7b7)
+++ i18n/English.ts	(revision 5354a013118fd7e0ec3e0680ec9c806f5ba5ac4c)
@@ -2,4 +2,12 @@
 <!DOCTYPE TS><TS version="1.1">
 <context encoding="UTF-8">
+    <name>CTSPModel</name>
+    <message encoding="UTF-8">
+        <location filename="../src/tspmodel.cpp" line="50"/>
+        <source>Город %1</source>
+        <translation type="unfinished"></translation>
+    </message>
+</context>
+<context encoding="UTF-8">
     <name>MainWindow</name>
     <message encoding="UTF-8">
@@ -19,126 +27,121 @@
     </message>
     <message encoding="UTF-8">
+        <location filename="../ui/mainwindow.ui" line="149"/>
+        <source>Заполнить таблицу случайными значениями</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message encoding="UTF-8">
+        <location filename="../ui/mainwindow.ui" line="152"/>
+        <source>Случайно</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message encoding="UTF-8">
+        <location filename="../ui/mainwindow.ui" line="162"/>
+        <source>Решить текущую задачу</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message encoding="UTF-8">
         <location filename="../ui/mainwindow.ui" line="165"/>
-        <source>Заполнить таблицу случайными значениями</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="168"/>
-        <source>Случайно</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="178"/>
-        <source>Решить текущую задачу</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="181"/>
         <source>Решить</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="247"/>
+        <location filename="../ui/mainwindow.ui" line="231"/>
         <source>&amp;Файл</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="254"/>
+        <location filename="../ui/mainwindow.ui" line="238"/>
         <source>Со&amp;хранить</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="276"/>
+        <location filename="../ui/mainwindow.ui" line="260"/>
         <source>&amp;Настройки</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="282"/>
+        <location filename="../ui/mainwindow.ui" line="266"/>
         <source>&amp;Помощь</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="324"/>
+        <location filename="../ui/mainwindow.ui" line="308"/>
         <source>&amp;Настройка печати</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="338"/>
+        <location filename="../ui/mainwindow.ui" line="322"/>
         <source>&amp;Печать...</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="352"/>
+        <location filename="../ui/mainwindow.ui" line="336"/>
         <source>&amp;Ход решения</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="363"/>
+        <location filename="../ui/mainwindow.ui" line="347"/>
         <source>&amp;Граф решения</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="388"/>
+        <location filename="../ui/mainwindow.ui" line="372"/>
         <source>&amp;Создать</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="402"/>
+        <location filename="../ui/mainwindow.ui" line="386"/>
         <source>&amp;Открыть</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="419"/>
+        <location filename="../ui/mainwindow.ui" line="403"/>
         <source>&amp;Параметры</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="430"/>
+        <location filename="../ui/mainwindow.ui" line="414"/>
         <source>&amp;Содежание</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="441"/>
+        <location filename="../ui/mainwindow.ui" line="425"/>
         <source>&amp;Контекстная справка</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="452"/>
+        <location filename="../ui/mainwindow.ui" line="436"/>
         <source>&amp;Про...</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="460"/>
+        <location filename="../ui/mainwindow.ui" line="447"/>
         <source>В&amp;ыход</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="463"/>
+        <location filename="../ui/mainwindow.ui" line="450"/>
         <source>Выйти из программы</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="344"/>
+        <location filename="../ui/mainwindow.ui" line="328"/>
         <source>Ctrl+P</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="483"/>
+        <location filename="../ui/mainwindow.ui" line="470"/>
         <source>Ctrl+S</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="394"/>
+        <location filename="../ui/mainwindow.ui" line="378"/>
         <source>Ctrl+N</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="411"/>
+        <location filename="../ui/mainwindow.ui" line="395"/>
         <source>Ctrl+O</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message encoding="UTF-8">
-        <location filename="../src/mainwindow.cpp" line="83"/>
-        <source>Город </source>
         <translation type="unfinished"></translation>
     </message>
@@ -154,9 +157,4 @@
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="90"/>
-        <source>Количество городов, которые обходит окммивояжер</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message encoding="UTF-8">
         <location filename="../ui/mainwindow.ui" line="121"/>
         <source>Стоимости переходов/переездов из города в город</source>
@@ -164,96 +162,126 @@
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="194"/>
+        <location filename="../ui/mainwindow.ui" line="178"/>
         <source>Решение</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="211"/>
+        <location filename="../ui/mainwindow.ui" line="195"/>
         <source>Ход решения</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="221"/>
+        <location filename="../ui/mainwindow.ui" line="205"/>
         <source>Граф решения</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="327"/>
+        <location filename="../ui/mainwindow.ui" line="311"/>
         <source>Настроить принтер для печати</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="341"/>
+        <location filename="../ui/mainwindow.ui" line="325"/>
         <source>Распечатать результаты решения</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="355"/>
+        <location filename="../ui/mainwindow.ui" line="339"/>
         <source>Сохранить только хоод решения</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="366"/>
+        <location filename="../ui/mainwindow.ui" line="350"/>
         <source>Сохранить только граф решения</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="374"/>
+        <location filename="../ui/mainwindow.ui" line="358"/>
         <source>&amp;Решение</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="377"/>
+        <location filename="../ui/mainwindow.ui" line="361"/>
         <source>Сохранить ход и граф решения</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="391"/>
+        <location filename="../ui/mainwindow.ui" line="375"/>
         <source>Создать новую задачу</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="405"/>
+        <location filename="../ui/mainwindow.ui" line="389"/>
         <source>Открыть задачу</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="408"/>
+        <location filename="../ui/mainwindow.ui" line="392"/>
         <source>Открыть сохраненное условие задачи</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="422"/>
+        <location filename="../ui/mainwindow.ui" line="406"/>
         <source>Настройка параметров программмы</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="433"/>
+        <location filename="../ui/mainwindow.ui" line="417"/>
         <source>Вызвать справку по программе</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="444"/>
+        <location filename="../ui/mainwindow.ui" line="428"/>
         <source>Вызвать контекстную справку</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="471"/>
+        <location filename="../ui/mainwindow.ui" line="458"/>
         <source>&amp;Задачу</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="474"/>
+        <location filename="../ui/mainwindow.ui" line="461"/>
         <source>Сохранить</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="477"/>
+        <location filename="../ui/mainwindow.ui" line="464"/>
         <source>Сохранить задачу</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/mainwindow.ui" line="480"/>
+        <location filename="../ui/mainwindow.ui" line="467"/>
         <source>Сохранить условие задачи в файл</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message encoding="UTF-8">
+        <location filename="../src/mainwindow.cpp" line="83"/>
+        <source>Ошибка в данных</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message encoding="UTF-8">
+        <location filename="../src/mainwindow.cpp" line="83"/>
+        <source>Ошибка в ячейке [Строка %1; Колонка %2]: Неверный формат данных.</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message encoding="UTF-8">
+        <location filename="../src/mainwindow.cpp" line="92"/>
+        <source>Ошибка при решении</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message encoding="UTF-8">
+        <location filename="../src/mainwindow.cpp" line="92"/>
+        <source>Во время решения задачи возникла ошибка</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message encoding="UTF-8">
+        <location filename="../ui/mainwindow.ui" line="439"/>
+        <source>Получить информацию о программе</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message encoding="UTF-8">
+        <location filename="../ui/mainwindow.ui" line="90"/>
+        <source>Количество городов, которые обходит коммивояжер</source>
         <translation type="unfinished"></translation>
     </message>
@@ -307,10 +335,10 @@
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="412"/>
+        <location filename="../ui/settingsdialog.ui" line="409"/>
         <source>&amp;OK</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/settingsdialog.ui" line="431"/>
+        <location filename="../ui/settingsdialog.ui" line="428"/>
         <source>&amp;Отмена</source>
         <translation type="unfinished"></translation>
@@ -347,9 +375,4 @@
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/settingsdialog.ui" line="305"/>
-        <source>Открывать окно в том же положении и с теми же размерами, с какими оно было закрыто</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message encoding="UTF-8">
         <location filename="../ui/settingsdialog.ui" line="359"/>
         <source>Справка</source>
@@ -357,16 +380,21 @@
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/settingsdialog.ui" line="390"/>
-        <source>Наведите указателем мыши на требуемый элемент диалога, чтоб получить подсказку</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message encoding="UTF-8">
-        <location filename="../ui/settingsdialog.ui" line="409"/>
+        <location filename="../ui/settingsdialog.ui" line="406"/>
         <source>Сохранить новые параметры</source>
         <translation type="unfinished"></translation>
     </message>
     <message encoding="UTF-8">
-        <location filename="../ui/settingsdialog.ui" line="428"/>
+        <location filename="../ui/settingsdialog.ui" line="425"/>
         <source>Закрыть окно без сохранения параметров</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message encoding="UTF-8">
+        <location filename="../ui/settingsdialog.ui" line="305"/>
+        <source>Восстанавливать состояние и размеры окна после перезапуска программы</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message encoding="UTF-8">
+        <location filename="../ui/settingsdialog.ui" line="384"/>
+        <source>Наведите указатель мыши на элемент диалога, чтоб получить подсказку</source>
         <translation type="unfinished"></translation>
     </message>